//+------------------------------------------------------------------+
//|                                        Waver V0.10 built 610.mq4 |
//|                                            Copyright 2014, Kajos |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Kajos"
#property link      ""
#property version   "1.00"
#property strict

extern double SWP             = 0.0007;
extern bool   ShowPips        = false;
extern bool   ShowPercent     =false;
extern int    PVLength        = -3;
extern double PVOffset        = 0.00;


string swpID="swp_";
bool Change;
int PeakTime[];
int ValleyTime[];
double PeakPrice[],PeakFibo[],
ValleyPrice[],ValleyFibo[];
color  ValleyColor=Orange,
PeakColor=DeepSkyBlue;
int    Moving,CandleBuffer;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
//EventSetTimer(60);

//---
   Print(INIT_SUCCEEDED);
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
//EventKillTimer();

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   Change=swingPoint(SWP,PeakTime,PeakPrice,PeakFibo,
                     ValleyTime,ValleyPrice,ValleyFibo,
                     Moving,ShowPips,ShowPercent,
                     PeakColor,ValleyColor,
                     PVLength,PVOffset);

  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---

  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---

  }
//+------------------------------------------------------------------+
bool swingPoint(double swp,int &peakTime[],double &peakPrice[],double &peakFibo[],
                int &valleyTime[],double &valleyPrice[],double &valleyFibo[],
                int &moving,bool showStr=false,bool showStr2=false,color peakColor=Lime,color valleyColor=Red,int lineHeight=0,double pvOffset=0.0)
  {
   int firstBars=Bars;
   int peakCnt=ArraySize(peakTime);
   int valleyCnt=ArraySize(valleyTime);
   int iTmp=0;
   double tmppvOffset;

//Print("pcnt: "+peakCnt);
//Print("vcnt: "+valleyCnt);
   string str,str2;
/*
		double peakDistance1 = (WindowPriceMax()-WindowPriceMin())/25,
			   peakDistance2 = (WindowPriceMax()-WindowPriceMin())/15,
			   valleyDistance1 = (WindowPriceMax()-WindowPriceMin())/100,
			   valleyDistance2 = (WindowPriceMax()-WindowPriceMin())/30;
		*/
   double peakDistance1=50,
   peakDistance2=100,
   valleyDistance1 = 50,
   valleyDistance2 = 100;
   int i,ii;

//---- no pv first run
   if(peakCnt==0 || valleyCnt==0)
     {
      for(i=firstBars; i>=0; i--)
        {
         if(i==firstBars)
           {
            peakCnt=makeNewPeak(peakTime,peakPrice,peakFibo,
                                valleyTime,valleyPrice,valleyFibo,
                                Time[i],High[i]);
            valleyCnt=makeNewValley(valleyTime,valleyPrice,valleyFibo,
                                    peakTime,peakPrice,peakFibo,
                                    Time[i],Low[i]);

            tmppvOffset=(High[i]-Low[i])*pvOffset;
            peakDraw(swp,ds(peakCnt,0),Time[i],High[i],peakColor,lineHeight,tmppvOffset);
            valleyDraw(swp,ds(valleyCnt,0),Time[i],Low[i],valleyColor,lineHeight,tmppvOffset);
            for(ii=i-1; ii>=0; ii--)
              {
               if(High[ii]>peakPrice[0]+swp)
                 {
                  peakCnt=setLastPeak(peakTime,peakPrice,peakFibo,
                                      valleyTime,valleyPrice,valleyFibo,
                                      Time[ii],High[ii]);
                  moving=0; // UP movin'
                  tmppvOffset=(High[ii]-Low[ii])*pvOffset;
                  peakDraw(swp,ds(peakCnt,0),Time[ii],High[ii],peakColor,lineHeight,tmppvOffset);
                  //Print("P ", peakCnt, " ", High[ii]);
                  i=ii;
                  break;
                 }
               if(Low[ii]<valleyPrice[0]-swp)
                 {
                  valleyCnt=setLastValley(valleyTime,valleyPrice,valleyFibo,
                                          peakTime,peakPrice,peakFibo,
                                          Time[ii],Low[ii]);
                  moving=1; // DN movin'
                  tmppvOffset=(High[ii]-Low[ii])*pvOffset;
                  valleyDraw(swp,ds(valleyCnt,0),Time[ii],Low[ii],valleyColor,lineHeight,tmppvOffset);
                  //Print("v", valleyCnt, " ", Low[ii]);
                  i=ii;
                  break;
                 }
              }

            ObjectCreate("start",OBJ_VLINE,0,Time[ii],0);
            continue;
           }

         if(moving==0) // UP movin'
           {
            for(ii=i; ii>=0; ii--)
              {
               if(High[ii]>peakPrice[0]) // peak increasing
                 {
                  peakCnt=setLastPeak(peakTime,peakPrice,peakFibo,
                                      valleyTime,valleyPrice,valleyFibo,
                                      Time[ii],High[ii]);
                  tmppvOffset=(High[ii]-Low[ii])*pvOffset;
                  peakDraw(swp,ds(peakCnt,0),Time[ii],High[ii],peakColor,lineHeight,tmppvOffset);
                  if(showStr)
                    {
                     str=ds((peakPrice[0]-valleyPrice[0])/Point,0)+" / "+ds((peakPrice[0]-valleyPrice[0])/swp,2);
                     //peakText(swp, "pstr"+peakCnt, str, Time[ii], High[ii], peakColor, peakDistance1*Point+tmppvOffset);
                    }
                  if(showStr2)
                    {
                     str2=ds(peakFibo[0],2)+"%";
                     //peakText(swp, "pstr2"+peakCnt, str2, Time[ii], High[ii], peakColor, peakDistance2*Point+tmppvOffset);
                    }
                  i=ii;
                  break;
                 }
               if(Low[ii]<peakPrice[0]-swp) // new valley
                 {
                  valleyCnt=makeNewValley(valleyTime,valleyPrice,valleyFibo,
                                          peakTime,peakPrice,peakFibo,
                                          Time[ii],Low[ii]);
                  str=ds((peakPrice[0]-valleyPrice[0])/Point,0);
                  tmppvOffset=(High[ii]-Low[ii])*pvOffset;
                  valleyDraw(swp,ds(valleyCnt,0),Time[ii],Low[ii],valleyColor,lineHeight,tmppvOffset);
                  if(showStr)
                    {
                     str=ds((peakPrice[0]-valleyPrice[0])/Point,0)+" / "+ds((peakPrice[0]-valleyPrice[0])/swp,2);
                     //valleyText(swp, "vstr"+valleyCnt, str, Time[ii], Low[ii], valleyColor, valleyDistance1*Point+tmppvOffset);
                    }
                  if(showStr2)
                    {
                     str2=ds(valleyFibo[0],2)+"%";
                     //valleyText(swp, "vstr2"+valleyCnt, str2, Time[ii], Low[ii], valleyColor, valleyDistance2*Point+tmppvOffset);
                    }
                  moving=1; // DN movin'
                  i=ii;
                  break;
                 }
              }
            continue;
           }
         if(moving==1) // DN movin'
           {
            for(ii=i; ii>=0; ii--)
              {
               if(Low[ii]<valleyPrice[0]) // valley increasing
                 {
                  valleyCnt=setLastValley(valleyTime,valleyPrice,valleyFibo,
                                          peakTime,peakPrice,peakFibo,
                                          Time[ii],Low[ii]);
                  tmppvOffset=(High[ii]-Low[ii])*pvOffset;
                  valleyDraw(swp,ds(valleyCnt,0),Time[ii],Low[ii],valleyColor,lineHeight,tmppvOffset);
                  if(showStr)
                    {
                     str=ds((peakPrice[0]-valleyPrice[0])/Point,0)+" / "+ds((peakPrice[0]-valleyPrice[0])/swp,2);
                     //valleyText(swp, "vstr"+valleyCnt, str, Time[ii], Low[ii], valleyColor, valleyDistance1*Point+tmppvOffset);
                    }
                  if(showStr2)
                    {
                     str2=ds(valleyFibo[0],2)+"%";
                     //valleyText(swp, "vstr2"+valleyCnt, str2, Time[ii], Low[ii], valleyColor, valleyDistance2*Point+tmppvOffset);
                    }
                  i=ii;
                  break;
                 }
               if(High[ii]>valleyPrice[0]+swp) // new peak
                 {
                  peakCnt=makeNewPeak(peakTime,peakPrice,peakFibo,
                                      valleyTime,valleyPrice,valleyFibo,
                                      Time[ii],High[ii]);
                  tmppvOffset=(High[ii]-Low[ii])*pvOffset;
                  peakDraw(swp,ds(peakCnt,0),Time[ii],High[ii],peakColor,lineHeight,tmppvOffset);
                  if(showStr)
                    {
                     str=ds((peakPrice[0]-valleyPrice[0])/Point,0)+" / "+ds((peakPrice[0]-valleyPrice[0])/swp,2);
                     //peakText(swp, "pstr"+peakCnt, str, Time[ii], High[ii], peakColor, peakDistance1*Point+tmppvOffset);
                    }
                  if(showStr2)
                    {
                     str2=ds(peakFibo[0],2)+"%";
                     //peakText(swp, "pstr2"+peakCnt, str2, Time[ii], High[ii], peakColor, peakDistance2*Point+tmppvOffset);
                    }
                  moving=0; // DN movin'
                  i=ii;
                  break;
                 }
              }
            continue;
           }

        }
      return(true);
     }
//if(SwpBuffer==Time[0]) return(false);
//SwpBuffer=Time[0];
// LIVE
   while(true)
     {
      if(moving==0) // UP movin'
        {
         if(High[1]>peakPrice[0]) // peak increasing
           {
            peakCnt=setLastPeak(peakTime,peakPrice,peakFibo,
                                valleyTime,valleyPrice,valleyFibo,
                                Time[1],High[1]);
            tmppvOffset=(High[1]-Low[1])*pvOffset;
            peakDraw(swp,ds(peakCnt,0),Time[1],High[1],peakColor,lineHeight,tmppvOffset);
            if(showStr)
              {
               str=ds((peakPrice[0]-valleyPrice[0])/Point,0)+" / "+ds((peakPrice[0]-valleyPrice[0])/swp,2);
               //peakText(swp, "pstr"+peakCnt, str, Time[ii], High[ii], peakColor, peakDistance1*Point+tmppvOffset);
              }
            if(showStr2)
              {
               str2=ds(peakFibo[0],2)+"%";
               //peakText(swp, "pstr2"+peakCnt, str2, Time[ii], High[ii], peakColor, peakDistance2*Point+tmppvOffset);
              }
            break;
           }
         if(Low[1]<peakPrice[0]-swp && peakTime[0]!=Time[1]) // new valley
           {
            valleyCnt=makeNewValley(valleyTime,valleyPrice,valleyFibo,
                                    peakTime,peakPrice,peakFibo,
                                    Time[1],Low[1]);
            tmppvOffset=(High[1]-Low[1])*pvOffset;
            valleyDraw(swp,ds(valleyCnt,0),Time[1],Low[1],valleyColor,lineHeight,tmppvOffset);
            if(showStr)
              {
               str=ds((peakPrice[0]-valleyPrice[0])/Point,0)+" / "+ds((peakPrice[0]-valleyPrice[0])/swp,2);
               //valleyText(swp, "vstr"+valleyCnt, str, Time[ii], Low[ii], valleyColor, valleyDistance1*Point+tmppvOffset);
              }
            if(showStr2)
              {
               str2=ds(valleyFibo[0],2)+"%";
               //valleyText(swp, "vstr2"+valleyCnt, str2, Time[ii], Low[ii], valleyColor, valleyDistance2*Point+tmppvOffset);
              }

            moving=1; // DN movin'
            return(true);
           }
        }
      if(moving==1) // DN movin'
        {
         if(Low[1]<valleyPrice[0]) // valley increasing
           {
            valleyCnt=setLastValley(valleyTime,valleyPrice,valleyFibo,
                                    peakTime,peakPrice,peakFibo,
                                    Time[1],Low[1]);
            tmppvOffset=(High[1]-Low[1])*pvOffset;
            valleyDraw(swp,ds(valleyCnt,0),Time[1],Low[1],valleyColor,lineHeight,tmppvOffset);
            if(showStr)
              {
               str=ds((peakPrice[0]-valleyPrice[0])/Point,0)+" / "+ds((peakPrice[0]-valleyPrice[0])/swp,2);
               //valleyText(swp, "vstr"+valleyCnt, str, Time[ii], Low[ii], valleyColor, valleyDistance1*Point+tmppvOffset);
              }
            if(showStr2)
              {
               str2=ds(valleyFibo[0],2)+"%";
               //valleyText(swp, "vstr2"+valleyCnt, str2, Time[ii], Low[ii], valleyColor, valleyDistance2*Point+tmppvOffset);
              }
            break;
           }
         if(High[1]>valleyPrice[0]+swp && valleyTime[0]!=Time[1]) // new peak
           {
            peakCnt=makeNewPeak(peakTime,peakPrice,peakFibo,
                                valleyTime,valleyPrice,valleyFibo,
                                Time[1],High[1]);
            tmppvOffset=(High[1]-Low[1])*pvOffset;
            peakDraw(swp,ds(peakCnt,0),Time[1],High[1],peakColor,lineHeight,tmppvOffset);
            if(showStr)
              {
               str=ds((peakPrice[0]-valleyPrice[0])/Point,0)+" / "+ds((peakPrice[0]-valleyPrice[0])/swp,2);
               //peakText(swp, "pstr"+peakCnt, str, Time[ii], High[ii], peakColor, peakDistance1*Point+tmppvOffset);
              }
            if(showStr2)
              {
               str2=ds(peakFibo[0],2)+"%";
               //peakText(swp, "pstr2"+peakCnt, str2, Time[ii], High[ii], peakColor, peakDistance2*Point+tmppvOffset);
              }

            moving=0; // DN movin'
            return(true);
           }
        }
      break;
     }
   return(false);

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int makeNewPeak(int &peakTime[],double &peakPrice[],double &peakFibo[],
                int &valleyTime[],double &valleyPrice[],double &valleyFibo[],
                int time,double price)
  {
   int peakCnt=ArraySize(peakTime);
   ArraySetAsSeries(peakTime,true);
   ArraySetAsSeries(peakPrice,true);
   ArraySetAsSeries(peakFibo,true);
//ArraySetAsSeries(peakSR, true);
//ArraySetAsSeries(peakSRTime, true);
   ArrayResize(peakTime,peakCnt+1,1000);
   ArrayResize(peakPrice,peakCnt+1,1000);
   ArrayResize(peakFibo,peakCnt+1,1000);
//ArrayResize(peakSR, peakCnt+1);
//ArrayResize(peakSRTime, peakCnt+1);
   ArraySetAsSeries(peakTime,false);
   ArraySetAsSeries(peakPrice,false);
   ArraySetAsSeries(peakFibo,false);
//ArraySetAsSeries(peakSR, false);
//ArraySetAsSeries(peakSRTime, false);
   peakTime[0]=time;
   peakPrice[0]= price;
   //peakFibo[0] = percent((peakPrice[1]-valleyPrice[0]),(peakPrice[0]-valleyPrice[0]));
   return(peakCnt+1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int makeNewValley(int &valleyTime[],double &valleyPrice[],double &valleyFibo[],
                  int &peakTime[],double &peakPrice[],double &peakFibo[],
                  int time,double price)
  {
   int valleyCnt=ArraySize(valleyTime);
   ArraySetAsSeries(valleyTime,true);
   ArraySetAsSeries(valleyPrice,true);
   ArraySetAsSeries(valleyFibo,true);
   ArrayResize(valleyTime,valleyCnt+1);
   ArrayResize(valleyPrice,valleyCnt+1);
   ArrayResize(valleyFibo,valleyCnt+1);
   ArraySetAsSeries(valleyTime,false);
   ArraySetAsSeries(valleyPrice,false);
   ArraySetAsSeries(valleyFibo,false);

   valleyTime[0]=time;
   valleyPrice[0]=price;
   //valleyFibo[0]=percent((peakPrice[0]-valleyPrice[1]),(peakPrice[0]-valleyPrice[0]));
   return(valleyCnt+1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int setLastPeak(int &peakTime[],double &peakPrice[],double &peakFibo[],
                int &valleyTime[],double &valleyPrice[],double &valleyFibo[],
                int time,double price)
  {
   int peakCnt = ArraySize(peakTime);
   peakTime[0] = time;
   peakPrice[0]= price;
   //peakFibo[0] = percent((peakPrice[1]-valleyPrice[0]),(peakPrice[0]-valleyPrice[0]));
/*
		valleyFibo[0] = percent( (peakPrice[1]-valleyPrice[1]), (peakPrice[1]-valleyPrice[0]));
		*/
   return(peakCnt);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int setLastValley(int &valleyTime[],double &valleyPrice[],double &valleyFibo[],
                  int &peakTime[],double &peakPrice[],double &peakFibo[],
                  int time,double price)
  {
   int valleyCnt = ArraySize(valleyTime);
   valleyTime[0] = time;
   valleyPrice[0]= price;
   //valleyFibo[0] = percent((peakPrice[0]-valleyPrice[1]),(peakPrice[0]-valleyPrice[0]));
   return(valleyCnt);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void peakDraw(double swp,string name,int time1,double price1,color clr,int lineHeight,double pvOffset)
  {
   name=swpID+"("+ds(swp,Digits)+") peak: "+name;
   int size=5;
   ObjectCreate(name,OBJ_TREND,0,0,0);
   ObjectSet(name,OBJPROP_PRICE1,price1+pvOffset);
   ObjectSet(name,OBJPROP_PRICE2,price1+pvOffset);
   ObjectSet(name,OBJPROP_TIME1,time1);
   if(lineHeight==0)
     {
      ObjectSet(name,OBJPROP_TIME2,time1);
     }
   else
     {
      ObjectSet(name,OBJPROP_TIME2,time1+Period()*60*lineHeight);
      size=2;
     }
   ObjectSet(name,OBJPROP_COLOR,clr);
   ObjectSet(name,OBJPROP_WIDTH,size);
   ObjectSet(name,OBJPROP_BACK,false);
   ObjectSet(name,OBJPROP_RAY,false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void valleyDraw(double swp,string name,int time1,double price1,color clr,int lineHeight,double pvOffset)
  {
   name=swpID+"("+ds(swp,Digits)+") valley: "+name;
//name = swpID+swp+"valley"+Magic+name;
   int size=5;
//Print(pvOffset);
//pvOffset = (High[1]-Low[1])*pvOffset;
//Print(pvOffset);
   ObjectCreate(name,OBJ_TREND,0,time1,price1);
   ObjectSet(name,OBJPROP_PRICE1,price1-pvOffset);
   ObjectSet(name,OBJPROP_PRICE2,price1-pvOffset);
   ObjectSet(name,OBJPROP_TIME1,time1);
   if(lineHeight==0)
     {
      ObjectSet(name,OBJPROP_TIME2,time1);
     }
   else
     {
      ObjectSet(name,OBJPROP_TIME2,time1+Period()*60*lineHeight);
      size=2;
     }
   ObjectSet(name,OBJPROP_COLOR,clr);
   ObjectSet(name,OBJPROP_WIDTH,size);
   ObjectSet(name,OBJPROP_BACK,false);
   ObjectSet(name,OBJPROP_RAY,false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double n(double price)
  {
   return(NormalizeDouble(price, Digits));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double nd(double price,int digit)
  {
   return(NormalizeDouble(price, digit));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string ds(double dvalue,int digit)
  {
   return(DoubleToStr(dvalue, digit));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double percent(double a,double b)
  {
   if(a==0.0)return(1);
   double onePerc,resoult;
   onePerc = nd(a/100, 5);
   resoult = nd(b/onePerc, 5);
   return(resoult);

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double percentValue(double a,double b)
  {
   if(a==0.0)return(1);
   double onePerc,resoult;
   onePerc = nd(a/100, 5);
   resoult = nd(onePerc*b, 5);
   return(resoult);
  }
//+------------------------------------------------------------------+
